/** 
 *   This class was created to manipulate the time object
 * 
 */

import java.sql.Time;
import java.lang.Math;
import java.lang.Object.*;

public class TimeBase
{
    public int centisecond;
    
    
    /** Basic Constructor of the class. it sets the attribute centisecond to 0
     */
    public TimeBase()
    {
	centisecond=0;
    }
    
    /** Constructor of the Class set the attribute centisecon to timeCenti
     *@param timeCenti int which represent the number of centiseconds.
     */ 
    public TimeBase (int timeCenti)
    {
	this.centisecond=timeCenti;
    }
    
   
    
    /**
     * Constructor creating TimeBase Object from different date string formats.
     *<pre> 
     *type can have 4 different values :
     *                        - "src_sgm"    : dateTime is like HH:MM:ss.cc  ex : 21:39:46.78
     *                        - "submission" : dateTime is like sss.cc     ex: 198.28
     *                        - "clipping"   : dateTime is like sss.mmm     ex: 198.287
     *                        - "length"     : dateTime is like MM:SS:mmm  ex: 28:27:198
     *                        - "alignment"  : dateTime is like ss.cc or -ss.cc ex: -28.64
     *For the clipping and the length we only keep the centiseconds.
     *</pre>
     *@param dateTime it is a string from a file of submission or refrence or offset of the table of length
     *@param type string which can have 4 values as it is decribed above.
     */
    public TimeBase(String dateTime, String type)
    {
	int tmp=0;
	char[] tmpchar= new char[3];

	if (type.equals("src_sgm"))
	    {
		String[] time=dateTime.trim().split(":");
		String[] sec= time[2].trim().split("\\.");
		Integer hour= new Integer(time[0]);
		Integer minutes= new Integer(time[1]);
		Integer secondes= new Integer(sec[0]);
		Integer cents= new Integer(sec[1]);
		
		
		if(sec[1].length()>1)
		    tmp = hour.intValue()*3600*100 + minutes.intValue()*60*100 + secondes.intValue()*100 + cents.intValue();
		else
		    tmp = hour.intValue()*3600*100 + minutes.intValue()*60*100 +secondes.intValue()*100+cents.intValue()*10;
				
	    }
	else if(type.equals("submission"))
	    {
		
		  String[] time = dateTime.trim().split("\\.");
		  Integer secondes = new Integer(time[0]);
		  
		  if(time.length > 1)
		      {
			  if (time[1].length()>1)
			      {
				  Integer cents = new Integer(time[1]);
				  tmp = secondes.intValue()*100 + cents.intValue();
			      }
			  else
			      {
				  Integer cents = new Integer(time[1]);
				  tmp = secondes.intValue()*100 + cents.intValue()*10;
			      }  
		      }
		  else
		      tmp = secondes.intValue()*100;
		  
		  //System.out.println("date time String : "+dateTime +" int : "+tmp);	
	    }
	else if(type.equals("clipping"))
	    {
		String[] time = dateTime.trim().split("\\.");
		  Integer secondes = new Integer(time[0]);
		  Integer milisecondes = new Integer(time[1]);
		  tmp = secondes.intValue()*100 + (milisecondes.intValue()/10);
	    }
	else if(type.equals("length"))
	    {
		String[] time=dateTime.trim().split(":");
		Integer minutes= new Integer(time[0]);
		Integer secondes= new Integer(time[1]);
		Integer milisecondes= new Integer(time[2]);

		tmp=minutes.intValue()*60*100 +secondes.intValue()*100+ (milisecondes.intValue()/10);
	    }
	else if(type.equals("alignment"))
	    {
		String[] time = dateTime.trim().split("\\.");
				  
		if(!dateTime.startsWith("-"))
		    {
			Integer secondes = new Integer(time[0]);
			if(time.length > 1)
			    {
				if (time[1].length()>1)
				    {
					Integer cents = new Integer(time[1]);
					tmp = secondes.intValue()*100 + cents.intValue();
				    }
				else
				    {
					Integer cents = new Integer(time[1]);
					tmp = secondes.intValue()*100 + cents.intValue()*10;
				    }  
			    }
			else
			    tmp = secondes.intValue()*100;	
		    }
		else
		    {
			Integer secondes = new Integer(time[0].substring(1));
			if(time.length > 1)
			    {
				if (time[1].length()>1)
				    {
					Integer cents = new Integer(time[1]);
					tmp = (-1)*(secondes.intValue()*100 + cents.intValue());
				    }
				else
				    {
					Integer cents = new Integer(time[1]);
					tmp =(-1)*(secondes.intValue()*100 + cents.intValue()*10);
				    }  
			    }
			else
			    tmp = (-1)*secondes.intValue()*100;
			
		    }
	    }
	else
	    System.out.println("Error wrong type in the TimeBase creation");
	
	this.centisecond=tmp;
	//System.out.println("centisecond : "+centisecond);
	
    }


    /**
     * Return the attribute centisecond of a TimeBase object
     *@return an int
     */
    public int getint()
    {
	return this.centisecond;
    }

    /**
     * Convert a TimeBase Object into a String in format sssss.cc which is the time format of the submissions
     * @return the string convertion
     */
    public String toString()
    {
	String result;

	Integer sec = new Integer(Math.abs(this.centisecond)/100);
	Integer cents = new Integer (Math.abs(this.centisecond)%100);
	String se =  sec.toString();
	String cent = cents.toString();
	
	//If the String looks like 03, the outpu will skip the 0 and will return 3 taht why we have to concat a 0 in that case
	if(cents.intValue()<10)
	    result = se.concat(".").concat("0").concat(cent);
	else
	    result = se.concat(".").concat(cent);
	if(centisecond <0)
	    return "-".concat(result);
	else 
	    return result;
    }
 
    /**
     *Convert a TimeBase Object into a String in format HH:MM:ss.cc which is the time format of the reference
     * @return the string convertion
     */
    public String toHHMMssString()
    {
	Integer sec = new Integer(this.centisecond/100);
	Integer cents = new Integer (this.centisecond%100);
	
	Integer hours = new Integer(sec.intValue()/3600);
	int tmp = sec.intValue() - hours.intValue()*3600;
	Integer minutes = new Integer(tmp/60);
	Integer secondes = new Integer(tmp%60);
	
	String se =  secondes.toString();
	String cent = cents.toString();
	String minutesString = minutes.toString();
	String hoursString = hours.toString();
	
	//If the String looks like 03, the outpu will skip the 0 and will return 3 taht why we have to concat a 0 in that case
	if(cents.intValue()<10)
	    return hoursString.concat(":").concat(minutesString).concat(":").concat(se).concat(".").concat("0").concat(cent);
	else
	    return  hoursString.concat(":").concat(minutesString).concat(":").concat(se).concat(".").concat(cent);
    }


    /**
     * Get the length of time between the current TimeBase and the one in argument
     *@return a TimeBase Object equal to the length between the two times
     *@param time2 TimeBase object defining a segment
     */

    public TimeBase getDifferenceBetween(TimeBase time2)
    {
	int t1 = this.getint();
	int t2 = time2.getint();
	
	if( t2 > t1)
	    return new TimeBase(t2 - t1);
	else
	    return new TimeBase(t1 - t2);
    }

    /**
     *Method used to add two TimeBase object
     *@return a TimeBase object which is the result of the addition
     *@param time2 the timeBase object you want to add to the current one
     */
    public TimeBase add(TimeBase time2)
    {
	int t1 = this.getint();
	int t2 = time2.getint();

	return new TimeBase(t1+t2);
    }

}

